/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package macampcorp.macamp.game.scheduler;


import macampcorp.macamp.activities.HostActivity;
import macampcorp.macamp.game.Event;
import macampcorp.macamp.game.Game;

public class EventTask extends Task {
    protected Event mEvent;

    public EventTask(Event e) {
        super(TASK_EVENT);
        mEvent = e;
    }


    public String toString()
    {
        return "[ Event, '"+mEvent.getMethod()+"' ]";
    }

    @Override
    public int exec(Scheduler s, HostActivity cd, Game g) {
        Event.EventReturn ev = mEvent.exec(cd, g);
        cd.save();
        if(!ev.wait) return s.schedule(cd, g);
        return Task.TASK_EVENT;
    }

    public Event getEvent() {
        return mEvent;
    }
}
